PrepareModeEvent = {};
PrepareModeEvent_mt = Class(PrepareModeEvent, Event);

InitEventClass(PrepareModeEvent, "PrepareModeEvent");

function PrepareModeEvent:emptyNew()
    local self = Event:new(PrepareModeEvent_mt);
    self.className="PrepareModeEvent";
    return self;
end;

function PrepareModeEvent:new(vehicle, state)
    local self = PrepareModeEvent:emptyNew()
    self.vehicle = vehicle;
	self.state = state;
    return self;
end;

function PrepareModeEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.state = streamReadBool(streamId);
    self.vehicle = networkGetObject(id);
    self:run(connection);
end;

function PrepareModeEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.vehicle));
	streamWriteBool(streamId, self.state);
end;

function PrepareModeEvent:run(connection)   
	self.vehicle:PrepareMode(self.state, true);
    if not connection:getIsServer() then
        g_server:broadcastEvent(PrepareModeEvent:new(self.vehicle, self.state), nil, connection, self.vehicle);
    end;
end;

function PrepareModeEvent.sendEvent(vehicle, state, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(PrepareModeEvent:new(vehicle, state), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(PrepareModeEvent:new(vehicle, state));
		end;
	end;
end;